apiVersion: v1
kind: Template
metadata:
  name: pkgbuild-deb-pipeline
  namespace: {{ namespace }}
objects:
- apiVersion: build.openshift.io/v1
  kind: BuildConfig
  metadata:
    annotations:
      description: Builds ${APPLICATION_NAME} DEB Packages
    name: ${APPLICATION_NAME}-deb-pipeline
  spec:
    strategy:
      jenkinsPipelineStrategy:
        jenkinsfile: |-
          try {
              def pkgname = "${APPLICATION_NAME}"
              def label = "${pkgname}-${UUID.randomUUID().toString()}"
              podTemplate(label: label, name: label, cloud: 'openshift',
                          containers: [ containerTemplate(name: 'jnlp', image: '{{ jenkins_debian_agent }}') ],
                          inheritFrom: 'nodejs', serviceAccount: '{{ jenkins_name }}') {
                  timeout(time: {{ jenkins_build_timeout | default(40) }}, unit: 'MINUTES') {
                      node (label) {
                          stage("Fetch") {
                              privateRepo = false
                              cloneProto = "http"
                              sh "git config --global http.sslVerify false"
                              sh "rm -fr ${pkgname} ; mkdir ${pkgname}"
                              try {
                                 withCredentials([string(credentialsId: "git-${pkgname}", variable: 'GIT_TOKEN')]) {
                                     privateRepo = true
                                     cloneProto = "https"
                                     echo "cloning ${REPO_URL} over https, using ${repoHost} token"
                                     try { git([ branch: "${REPO_REF}", url: "https://${GIT_TOKEN}@${REPO_URL}" ]) }
                                     catch(e2) {
                                         echo "Failed cloning ${REPO_URL}#${REPO_REF} - ${e2}"
                                     }
                                 }
                              } catch(e) {
                                  if (privateRepo != true) {
                                      echo "caught ${e} - assuming no credentials required"
                                      echo "cloning ${REPO_URL} over http"
                                      try { git([ branch: "${REPO_REF}", url: "${REPO_URL}" ]) }
                                      catch(e2) {
                                          echo "Failed cloning ${REPO_URL}#${REPO_REF} - ${e2}"
                                          throw e2
                                      }
                                  } else { throw e }
                              }
                          }
                          stage("Build") {
                              sh """
                              ( cd ${pkgname} ; git rev-parse --short HEAD ) >gitHash
                              ( cd ${pkgname} ; make createinitialarchive ; make createdebbin )
                              cat ${pkgname}/debian/changelog | awk '/${pkgname}/{print \$2;exit}' | sed -e 's|[()]||g' -e 's|.*-\\([0-9]*\\)\$|\\1|' >patchNumber
                              cat ${pkgname}/debian/changelog | awk '/${pkgname}/{print \$2;exit}' | sed -e 's|[()]||g' -e 's|\\(.*\\)-[0-9]*\$|\\1|' >versionNumber
                              """
                          }
                          stage("Upload") {
                              def gitHash = readFile('gitHash').trim()
                              def patch = readFile('patchNumber').trim()
                              def version = readFile('versionNumber').trim()
                              sh "echo Uploading artifacts for ${version}-${patch}-${gitHash}"
                              nexusArtifactUploader(
                                      nexusVersion: '{{ nexus_version | default('3.41.1') }}',
                                      protocol: "{{ nexus_proto | default('http') }}",
                                      nexusUrl: "{{ nexus_api_address | default('nexus:8081') }}",
                                      groupId: "{{ nexus_group_id | default('com.opsperator') }}",
                                      version: "${version}-${patch}-${gitHash}",
                                      repository: "{{ nexus_deb_repository | default('debian') }}",
{% if nexus_artifacts_secret | default(False) %}
                                      credentialsId: "{{ nexus_artifacts_secret }}",
{% endif %}
                                      artifacts: [
                                              [ artifactId: "${pkgname}-deb",
                                                classifier: '', type: 'deb',
                                                file: "${pkgname}_${version}-${patch}_all.deb" ],
                                              [ artifactId: "${pkgname}-deb",
                                                classifier: '', type: 'txt',
                                                file: "${pkgname}_${version}-${patch}_amd64.buildinfo" ],
                                              [ artifactId: "${pkgname}-deb",
                                                classifier: '', type: 'txt',
                                                file: "${pkgname}_${version}-${patch}_amd64.changes" ],
                                              [ artifactId: "${pkgname}-deb",
                                                classifier: '', type: 'tar.xz',
                                                file: "${pkgname}_${version}-${patch}.debian.tar.xz" ],
                                              [ artifactId: "${pkgname}-dev",
                                                classifier: '', type: 'tar.gz',
                                                file: "${pkgname}_${version}.orig.tar.gz" ],
                                              [ artifactId: "${pkgname}-deb",
                                                classifier: '', type: 'txt',
                                                file: "${pkgname}_${version}-${patch}.dsc" ]
                                          ]
                                  )
                          }
                      }
                  }
              }
          } catch (err) {
              echo "in catch block"
              echo "Caught: ${err}"
              currentBuild.result = 'FAILURE'
              throw err
          }
      type: JenkinsPipeline
parameters:
- name: APPLICATION_NAME
  description: Name for your Package
  required: true
- name: REPO_REF
  required: true
  value: master
- name: REPO_URL
  description: https://github.com/<your-git-url>
  required: true
